function [xmin,listex] = DescenteGradient_correction(f,x0,epsilon,tol,p0,recherche1D)

  % DescenteGradient
	 

  % Sécurité si on ne converge pas	 
  iterMax=1000;

  xmin = x0;
  listex=[xmin];

  compteur=0;
  while compteur < iterMax
    compteur = compteur + 1;

    x = xmin;
    gradf=CalculeGradient(f,x,epsilon);
   
    if recherche1D
      pas=SectionDoree(f,x,-gradf,p0,tol);
    else
      pas=p0;
    end

    xmin = x - pas * gradf;

    if nargout == 2  % Si la liste des points est ajoutée
       % On ajoute le point actuel à la liste
       listex=[listex xmin];
    end
    
    if norm(x-xmin)<tol
       % On sort de la boucle while
       break
    end
    
  end

  if compteur == iterMax
     warning('Nombre d’itérations maximal atteint dans DescenteGradient')
  end
end
