function y = ProjStereoInverse_correction(x)
  % ProjStereoInverse(x)
  % où x est un vecteur colonne (de taille n-1)
  % renvoie un vecteur colonne (de taille n) de norme 1
  % correspondant à la projection stéréographique inverse
	 
  a = norm(x)^2;
  y=[1-a;2*x]/(1+a);
  
end
